Summary: The most widely used Web server on the Internet, with modssl.
Name: apache-modssl
%define apachever 1.3.12
%define modsslver 2.6.6
Version: %{apachever}_%{modsslver}
Release: 1
Group: System Environment/Daemons
Copyright: Freely distributable and usable
Url: http://www.apache.org/httpd.html
Packager: Hao Li <hli@wag.caltech.edu>
Source0: ftp://ftp.apache.org/apache/dist/apache_%{apachever}.tar.gz
Source1: httpd.init
Source2: apache.logrotate
Source3: http://www.modssl.org/source/mod_ssl-%{modsslver}-%{apachever}.tar.gz
Patch0:  httpd.conf.patch
Patch1:  layout.patch
BuildRoot: /var/tmp/%{name}-root
Obsoletes: apache
Provides: apache

%description
Apache is a powerful, full-featured, efficient and freely-available
Web server. Apache is also the most popular Web server on the
Internet.

Server will run as httpd:httpd rather than nobody:nobody. 
Make sure user and group httpd exist before installing this package.

This package has modssl built-in, and comes with a set of dummy key and
certificate. Be sure to install your real key and certificate before
putting this server into real use.

Documentations are available at 
	http://www.apache.org/docs/
	http://www.modssl.org/docs/


%prep
rm -rf mod_ssl-%{modsslver}-%{apachever}
%setup -q -n apache_%{apachever} -b 3
%patch1 -p1


%build
# Configure mod_ssl
cd ../mod_ssl-%{modsslver}-%{apachever}
./configure --with-apache=../apache_%{apachever}

# Configure apache
cd ../apache_%{apachever}
SSL_BASE=SYSTEM EAPI_MM=SYSTEM \
OPTIM="$RPM_OPT_FLAGS" ./configure \
	--with-layout=RedHat \
	--disable-rule=WANTHSREGEX \
	--enable-module=all \
	--enable-shared=max \
	--with-perl=/usr/bin/perl \
	--with-port=80 \
	--server-uid=httpd --server-gid=httpd \
	--enable-module=ssl --enable-shared=ssl \
	--disable-rule=SSL_COMPAT \
	--enable-rule=SSL_SDBM
NCPU=`egrep -c ^processor /proc/cpuinfo`
export MAKE="make -j$NCPU"
$MAKE
make certificate TYPE=dummy


%install
rm -rf $RPM_BUILD_ROOT
make install root=$RPM_BUILD_ROOT
# Not all binaries are stripped. I guess there must be some reason ...
#strip $RPM_BUILD_ROOT/usr/{bin,sbin,lib/apache}/* ||:

# Remove bundled documentations and CGI examples
rm -rf $RPM_BUILD_ROOT/home/httpd/{cgi-bin,htdocs}/*

# Remove outdated configuration files
rm -f $RPM_BUILD_ROOT/etc/httpd/{access,srm}.conf{,.default}

# Patch default httpd.conf
patch $RPM_BUILD_ROOT/etc/httpd/httpd.conf %{PATCH0}
rm -f $RPM_BUILD_ROOT/etc/httpd/httpd.conf.orig
(cd $RPM_BUILD_ROOT/etc/httpd/; cp -p httpd.conf httpd.conf.default)

# install SYSV init stuff
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m755 %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/httpd

# install log rotation stuff
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
install -m644 %{SOURCE2} $RPM_BUILD_ROOT/etc/logrotate.d/apache


%post
/sbin/chkconfig --add httpd

%preun
if [ $1 = 0 ]; then
   /sbin/chkconfig --del httpd
fi


%files
%defattr(-,root,root)
%doc ABOUT_APACHE Announcement INSTALL KEYS LICENSE README* WARNING-NT.TXT

%dir /etc/httpd
%config /etc/httpd/*
%config /etc/logrotate.d/apache
%config /etc/rc.d/init.d/httpd

/home/httpd

/usr/bin/*
/usr/sbin/*
/usr/man/man*/*
/usr/include/apache
/usr/lib/apache

%dir %attr(-,httpd,httpd) /var/cache/httpd
%dir /var/log/httpd


%clean
rm -rf $RPM_BUILD_ROOT
